DefInt A-Z
			  
Declare Function GetClassWord Lib "user" (ByVal hWnd, ByVal nIndex)
Declare Function GetModuleFileName Lib "kernel" (ByVal hWnd, ByVal Fi As String, ByVal FiLen)
Declare Function GetModuleHandle Lib "kernel" (ByVal lpProgName$)
Declare Function GetModuleUsage Lib "kernel" (ByVal hModule)
Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
Declare Function GetWindowsDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer

Declare Function SendMessageBynum Lib "User" Alias "SendMessage" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Long) As Long
Declare Function SendMessageByString Lib "User" Alias "SendMessage" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As String) As Long

Global Const WM_USER = &H400
Global Const LB_SETSEL = (WM_USER + 6)

Global Const EM_GETLINECOUNT = WM_USER + 10
Global Const EM_GETLINE = WM_USER + 20
Global Const EM_LINEINDEX = WM_USER + 11
Global Const EM_LINELENGTH = WM_USER + 17

Type ut_RECT
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
End Type

Function BinarySearch (lb As ListBox, Search As String, LineNbr As Integer)
' Binary search of a listbox. Use like so:
'    Dim lineno As Integer
'    If BinarySearch(list1, (text1), lineno) = True Then
'        MsgBox "found at line " & lineno
'    Else
'        MsgBox "not found"
'    End If

Dim NbrRecs As Integer
Dim Found As Integer
Dim LoNbr As Integer
Dim HiNbr As Integer
Dim MidNbr As Integer

    NbrRecs = lb.ListCount
    Found = 0
    LoNbr = 0
    HiNbr = NbrRecs - 1

    Do
	MidNbr = (LoNbr + HiNbr) \ 2
	If UCase(Search) < UCase(lb.List(MidNbr)) Then
	    HiNbr = MidNbr - 1
	ElseIf UCase(Search) > UCase(lb.List(MidNbr)) Then
	    LoNbr = MidNbr + 1
	Else
	    Found = True
	    LineNbr = MidNbr
	End If
    Loop Until Found Or (HiNbr < LoNbr)
    BinarySearch = Found


End Function

Sub centerform (f As Form)
    f.Top = (screen.Height - f.Height) / 2
    f.Left = (screen.Width - f.Width) / 2

End Sub

Function FileExists (fspec As String) As Integer
    Dim dotpos As Integer
    Dim wspec As String

    On Error GoTo FileExistsError

    If Len(Trim(fspec)) = 0 Then
	FileExists = False
	Exit Function
    End If

    dotpos = InStr(fspec, ".")
    
    'catches autoexec.batxxx
    If dotpos > 0 Then
	If Len(fspec) > dotpos + 3 Then
	    FileExists = False
	    Exit Function
	End If
    End If
    
    'eliminates directories and the root
    If Right(Trim(fspec), 1) = "\" Or Right(Trim(fspec), 1) = ":" Then
	FileExists = False
	Exit Function
    End If

    'eliminate dos devices
    If UCase(fspec) = "AUX" Or UCase(fspec) = "COM" Or UCase(fspec) = "COM1" Or UCase(fspec) = "COM2" Or UCase(fspec) = "COM3" Or UCase(fspec) = "COM4" Or UCase(fspec) = "PRN" Or UCase(fspec) = "LPT1" Or UCase(fspec) = "LPT2" Or UCase(fspec) = "LPT3" Then
	FileExists = False
	Exit Function
    End If
    
    If Len(Dir$(fspec)) Then
	FileExists = True
    Else
	FileExists = False
    End If

    Exit Function

FileExistsError:
    FileExists = False
    Resume FileExistsErrorExit:

FileExistsErrorExit:
    Exit Function
End Function

Function IsAppRunning% (appexe$)
    hModule = GetModuleHandle(appexe$)
    Count = GetModuleUsage(hModule)
    If Count > 1 Then
	IsAppRunning = True
    Else
	IsAppRunning = False
    End If
    
    Exit Function
    
End Function

Sub SelectList (lb As ListBox, lb_state As Integer)
'-------------------------------------------------------
' Use this sub to quickly select or deselect all items
' in a multi-select listbox. If lb_state is True,
' then select all items. If false, then deselect all
' items
'-------------------------------------------------------
    Dim RetVal As Long
  
    If lb_state Then
	RetVal = SendMessage(lb.hWnd, LB_SETSEL, True, ByVal -1&)
    Else
	RetVal = SendMessage(lb.hWnd, LB_SETSEL, False, ByVal -1&)
    End If


End Sub

Sub selecttext (c As Control)
    c.SelStart = 0
    c.SelLength = Len(c.Text)

End Sub

Function StripCRLF (ByVal s As String) As String
    Dim tstring As String
    Dim i As Integer
    Dim tchar As String

    Dim CR As String * 1
    Dim LF As String * 1

    CR = Chr$(13)
    LF = Chr$(10)
    
    For i = 1 To Len(s)
	tchar = Mid$(s, i, 1)
	Select Case tchar
	    Case CR
		tstring = tstring & " "
	    Case LF
	    Case Else
		tstring = tstring & tchar
	End Select
    Next i

    StripCRLF = tstring

End Function

Function ValidFileName% (FileName$)
     Dim Buf As Integer

     On Local Error Resume Next
     
     ValidFileName% = True
     
     Buf = FreeFile
     
     Open FileName$ For Input As Buf
     
     If Err = 64 Then
	 ValidFileName% = False
     ElseIf Err = 0 Then
	 Close Buf
     End If

End Function

Function WinDir () As String
    Dim pbuffer As String
    Dim psize As Integer
    Dim X As Integer

    pbuffer = String$(144, " ")
    psize = 144
    
    X = GetWindowsDirectory(pbuffer, psize)
    
    If X <> 0 Then
	'remove trailing null
	WinDir = Mid(pbuffer, 1, Len(Trim(pbuffer)) - 1)
    Else
	WinDir = "error"
    End If

End Function

